package com.xxfc.platform.im.biz;




import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.mongodb.DBCollection;
import com.mongodb.DBCursor;
import com.mongodb.DBObject;
import com.xxfc.platform.im.model.Comment;
import com.xxfc.platform.im.model.Praise;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

@Component
public class MsgBiz {

    @Autowired
    private MongoTemplate mongoTemplate;

   DBCollection collection ;

    /**
     * 获取消息列表
     * @param map
     * @return
     * @throws Exception
     */
    public Object getMsgList(Map<String, Object> map)  throws Exception{
      /*  PageHelper.startPage(Integer.parseInt(map.get("page").toString()),Integer.parseInt(map.get("limit").toString()));
        PageInfo<Msg> goodPageInfo = new PageInfo<>(mongoTemplate.findAll(Msg.class));
       Query query = new Query(Criteria.where("userId").is(10000012));
        List<Msg> msg= mongoTemplate.findAll(Msg.class, "s_msg");*/
        if (null == collection)
            collection =  MGDBCollection.getDB().getCollection("s_msg");
        DBCursor cursor = collection.find();
        //collection.find()
        //return PageDataVO.pageInfo(goodPageInfo);

        JSONArray array = new JSONArray();
        DBObject dbObject = null;
        while(cursor.hasNext()){
            dbObject = cursor.next();
            JSONObject json = fetchAndAttach(JSONObject.parseObject(dbObject.toString()));
            array.add(json);
        }
        return  array;
    }

    private JSONObject fetchAndAttach(JSONObject json) {
        //查询评论
        Query query = new Query(Criteria.where("msgId").is(json.getString("_id")));
        List<Comment> msgComment = mongoTemplate.findAll(Comment.class);
        json.put("comments",msgComment);

        //查询点赞
        Query query1 = new Query(Criteria.where("msgId").is(json.getString("_id")));
        List<Praise> msgPraise = mongoTemplate.findAll(Praise.class);
        json.put("praises",msgPraise);
       /* msg.setComments(getComments(msg.getMsgId().toString()));
        msg.setPraises(getPraises(msg.getMsgId().toString()));
        msg.setGifts(SKBeanUtils.getMsgGiftRepository().find(msg.getMsgId(), null, 0, 10));
        msg.setIsPraise(SKBeanUtils.getMsgPraiseRepository().exists(ReqUtil.getUserId(), msg.getMsgId()) ? 1 : 0);
        msg.setIsCollect(SKBeanUtils.getMsgPraiseRepository().existsCollect(ReqUtil.getUserId(), msg.getMsgId()) ? 1 : 0);*/

        return json;
    }
}
